accounts/urls.py
from django.urls import path
from . import views

app_name = 'accounts'

urlpatterns = [
    path('login/', views.user_login, name='login'),
    path('register/', views.register, name='register'),
    path('logout/', views.user_logout, name='logout'),
    path('profile/<int:user_id>', views.profile, name='profile'),
    path('profile/change-password/', views.change_password, name='change-password'),
    path('profile/delete-account/', views.delete_user, name='delete-account'),
    path('profile/delete-account/<int:user_id>', views.delete_user_confirm, name='delete-account-confirm'),
]

cart/urls.py
from django.urls import path
from . import views

app_name = 'cart'

urlpatterns = [
    path('', views.cart, name='cart'),
    path('add/<int:product_id>', views.cart_add, name='cart_add'),
    path('remove/<int:product_id>', views.cart_remove, name='cart_remove'),
    path('update/', views.cart_update, name='cart_update')
]

company/urls.py
from django.urls import path
from . import views

app_name = 'company'

urlpatterns = [
    path('', views.home, name='home'),
    path('about/', views.about, name='about')
]

core/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf.urls.static import static
from core import settings

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('company.urls', namespace='company')),
    path('shop/', include('shop.urls', namespace='shop')),
    path('accounts/', include('accounts.urls', namespace='accounts')),
    path('cart/', include('cart.urls', namespace='cart')),
    path('orders/', include('orders.urls', namespace='orders')),
    path('checkout/', include('checkout.urls', namespace='checkout')),
]

accounts/models.py
from django.contrib.auth.models import AbstractBaseUser
from django.db import models
from .managers import MyUserManager
from django.db.models.signals import post_save


class User(AbstractBaseUser):
    email = models.EmailField(max_length=100, unique=True)
    full_name = models.CharField(max_length=100)
    is_admin = models.BooleanField(default=False)
    is_active = models.BooleanField(default=True)
    objects = MyUserManager()
    USERNAME_FIELD = 'email'
    REQUIRED_FIELDS = ['full_name']

    def __str__(self):
        return self.email

    def has_perm(self, perm, obj=None):
        return True

    def has_module_perms(self, app_label):
        return True

    @property
    def is_staff(self):
        return self.is_admin


class Profile(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE, related_name='profile')
    image = models.ImageField(upload_to='user_profile/', blank=True, default='1.jpg')
    bio = models.TextField(null=True, blank=True, default='Here is your bio')
    age = models.PositiveSmallIntegerField(null=True, blank=True)
    phone = models.PositiveIntegerField(null=True, blank=True)
    street = models.CharField(null=True, blank=True, max_length=200)
    city = models.CharField(null=True, blank=True, max_length=200)
    country = models.CharField(null=True, blank=True, max_length=200)
    state = models.CharField(null=True, blank=True, max_length=200)
    zip_code = models.CharField(null=True, blank=True, max_length=200)

    def __str__(self):
        return self.user.full_name


def save_profile(sender, **kwargs):
    if kwargs['created']:
        p1 = Profile(user=kwargs['instance'])
        p1.save()


post_save.connect(save_profile, sender=User)

accounts/forms.py
from django import forms
from .models import User, Profile
from django.contrib.auth.forms import ReadOnlyPasswordHashField


class UserCreationForm(forms.ModelForm):
    password1 = forms.CharField(label='password', widget=forms.PasswordInput)
    password2 = forms.CharField(label='confirm password', widget=forms.PasswordInput)

    class Meta:
        model = User
        fields = ('email', 'full_name')

    def clean_password2(self):
        cd = self.cleaned_data
        if cd['password1'] and cd['password2'] and cd['password1'] != cd['password2']:
            raise forms.ValidationError('passwords must match')
        return cd['password2']

    def save(self, commit=True):
        user = super().save(commit=False)
        user.set_password(self.cleaned_data['password1'])
        if commit:
            user.save()
        return user


class UserChangeForm(forms.ModelForm):
    password = ReadOnlyPasswordHashField()

    class Meta:
        model = User
        fields = ('email', 'password', 'full_name')

    def clean_password(self):
        return self.initial['password']


class UserLoginForm(forms.Form):
    email = forms.EmailField(widget=forms.EmailInput(attrs={'class': 'form-control'}))
    password = forms.CharField(widget=forms.PasswordInput(attrs={'class': 'form-control'}))


class UserRegistrationForm(forms.Form):
    full_name = forms.CharField(max_length=30,
                                widget=forms.TextInput(attrs={'placeholder': 'username'}))
    email = forms.EmailField(max_length=50,
                             widget=forms.EmailInput(attrs={'placeholder': 'your email'}))
    password1 = forms.CharField(max_length=50, widget=forms.PasswordInput(
        attrs={'placeholder': 'enter your password'}))
    password2 = forms.CharField(max_length=50, widget=forms.PasswordInput(
        attrs={'placeholder': 'enter your confirm password'}))

    def clean_email(self):
        email = self.cleaned_data['email']
        user = User.objects.filter(email=email)
        if user.exists():
            raise forms.ValidationError(
                'this email already exists ! plz enter enother one')
        return email

    def clean(self):
        clean_data = super().clean()
        p1 = clean_data.get('password1')
        p2 = clean_data.get('password2')
        if p1 and p2:
            if p1 != p2:
                raise forms.ValidationError('password must match')


class EditProfileForm(forms.ModelForm):
    full_name = forms.CharField(max_length=30,
                                widget=forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'full name'}))
    email = forms.EmailField(max_length=50,
                             widget=forms.EmailInput(attrs={'class': 'form-control', 'placeholder': 'your email'}))

    class Meta:
        model = Profile
        fields = ('bio', 'age', 'phone', 'street', 'city', 'state', 'zip_code', 'country', 'image')
        widgets = {
            'bio': forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'about you'}),
            'age': forms.NumberInput(attrs={'class': 'form-control', 'placeholder': 'age'}),
            'phone': forms.NumberInput(attrs={'class': 'form-control', 'placeholder': 'phone'}),
            'street': forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'street'}),
            'city': forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'city'}),
            'country': forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'country'}),
            'state': forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'state'}),
            'zip_code': forms.TextInput(attrs={'class': 'form-control', 'placeholder': 'zip code'}),
            'image': forms.FileInput(attrs={'class': 'account-settings-fileinput', 'form': 'profile-form'}),
        }


class PasswordChangingForm(forms.ModelForm):
    old_password = forms.CharField(
        widget=forms.PasswordInput(attrs={'class': 'form-control', 'placeholder': 'old password', 'type': 'password'}))
    new_password1 = forms.CharField(
        widget=forms.PasswordInput(attrs={'class': 'form-control', 'placeholder': 'New password', 'type': 'password'}))
    new_password2 = forms.CharField(widget=forms.PasswordInput(
        attrs={'class': 'form-control', 'placeholder': 'Confirm New password', 'type': 'password'}))

    class Meta:
        model = User
        fields = ('old_password', 'new_password1', 'new_password2')

    def clean(self):
        cleaned_data = super().clean()
        password = cleaned_data.get("new_password1")
        confirm_password = cleaned_data.get("new_password2")

        if password != confirm_password:
            raise forms.ValidationError(
                "password and confirm_password does not match"
            )

accounts/views.py
from django.contrib.auth import logout, authenticate, login
from django.contrib import messages
from .models import User
from django.contrib.auth.decorators import login_required
from django.shortcuts import render, redirect, get_object_or_404
from django.contrib.auth.hashers import check_password
from .forms import UserLoginForm, UserRegistrationForm, EditProfileForm, PasswordChangingForm


def user_login(request):
    if request.method == 'POST':
        form = UserLoginForm(request.POST)
        if form.is_valid():
            cd = form.cleaned_data
            user = authenticate(request, email=cd['email'], password=cd['password'])
            if user is not None:
                login(request, user)
                messages.success(request, 'you logged in successfully', 'success')
                return redirect('company:home')
            else:
                messages.error(request, 'username or password is wrong !', 'danger')
    else:
        form = UserLoginForm()

    return render(request, 'accounts/login.html', {'form': form})


def register(request):
    if request.method == 'POST':
        form = UserRegistrationForm(request.POST)
        if form.is_valid():
            cd = form.cleaned_data
            check = User.objects.filter(email__iexact=cd['email']).exists()
            if check:
                messages.error(request, 'please take another email !', 'danger')
            else:
                user = User.objects.create_user(full_name=cd['full_name'], email=cd['email'], password=cd['password1'])
                user.save()
                login(request, user)
                messages.success(request, 'you registered and login successfully', 'success')
                return redirect('company:home')
    else:
        form = UserRegistrationForm()
    return render(request, 'accounts/register.html', {'form': form})


def user_logout(request):
    logout(request)
    return redirect('company:home')


@login_required
def profile(request, user_id):
    user = get_object_or_404(User, pk=user_id)
    if request.method == 'POST':
        form = EditProfileForm(request.POST, request.FILES, instance=user.profile)
        if form.is_valid():
            form.save()
            user.email = form.cleaned_data['email']
            user.full_name = form.cleaned_data['full_name']
            user.save()
            messages.success(request, 'your profile edited successfully', 'success')
            return redirect('accounts:profile', user_id)
    else:
        form = EditProfileForm(instance=user.profile,
                               initial={'email': request.user.email,
                                        'full_name': request.user.full_name,
                                        'bio': request.user.profile.bio,
                                        'age': request.user.profile.age,
                                        'phone': request.user.profile.phone,
                                        'street': request.user.profile.street,
                                        'city': request.user.profile.city,
                                        'country': request.user.profile.country,
                                        'state': request.user.profile.state,
                                        'zip_code': request.user.profile.zip_code,
                                        'image': request.user.profile.image,
                                        })
    return render(request, 'accounts/profile.html', {'form': form})


@login_required
def change_password(request):
    if request.method == 'POST':
        current_password = request.user.password  # user's current password
        form = PasswordChangingForm(request.POST)
        if form.is_valid():
            current_password_entered = form.cleaned_data.get("old_password")
            password1 = form.cleaned_data.get("new_password1")
            match_check = check_password(current_password_entered, current_password)
            if match_check:
                request.user.set_password(password1)
                request.user.save()
                messages.success(request, 'password changed successfully!', 'success')
            else:
                messages.error(request, 'your current password entered is wrong !', 'danger')
        else:
            messages.error(request, 'please fill the form correctly !!', 'danger')
    else:
        form = PasswordChangingForm()
    return render(request, 'accounts/change-password.html', {'form': form})


@login_required
def delete_user(request):
    return render(request, 'accounts/delete-account.html')


@login_required
def delete_user_confirm(request, user_id):
    if request.user.id == user_id:
        user = User.objects.get(id=user_id)
        user.delete()
        messages.success(request, "Your accounts Deleted successfully ! ", 'success')
    else:
        messages.error(request, "User does not exist")
    return redirect('company:home')

accounts/templates/accounts/change-password.html
{% extends 'base.html' %}
{% load static %}
{%block content %}
<style>
	body {
    margin: 0;
    color: #2e323c;
    background: #f5f6fa;
    position: relative;
    height: 100%;
}

</style>
<div class="container" style="margin-top:70px;margin-bottom:70px">
    <div class="row gutters">
        <div class="col-lg-4 col-xl-4 col-md-12 col-sm-12 col-12">
            <div class="card-box text-center">
                <img src="{{ request.user.profile.image.url}}"
                     class="rounded-circle avatar-xl img-thumbnail" alt="profile-image">
                <h4 class="mb-0">{{request.user.full_name}}</h4>
                <p class="text-muted">{{request.user.email}}</p>
                <br>
                <label class="btn">
                    <i class="ti-upload"></i> Upload New photo
                    {{ form.image }}
                </label>
                <br>
                <br>
                <br>
                <div class="about">
                    <h5 class="mb-2 text-primary">About</h5>
                    <p>{{request.user.profile.bio}}</p>
                </div>
            </div>
            <hr class="border-light m-0">
            <div class="pt-0">
                <div class="list-group list-group-flush account-settings-links">
                    <a class="list-group-item list-group-item-action" href="{% url 'accounts:profile' request.user.id %}">General</a>
                    <a class="list-group-item list-group-item-action active" data-toggle="list"
                       href="#account-change-password">Change password</a>
                    <a class="list-group-item list-group-item-action" href="{% url 'accounts:delete-account' %}">Delete Account</a>
                </div>
            </div>
        </div>
        <div class="col-xl-8 col-lg-8 col-md-12 col-sm-12 col-12">
            <div class="tab-content">
                <div class="tab-pane fade active show" id="account-change-password">
                    <form method="post" id="change-password">
                        {% csrf_token %}
                        <div class="card h-100">
                            <div class="card-body">
                                <div class="row gutters">
                                    <div class="col-xl-12 col-lg-12 col-md-12 col-sm-12 col-12">
                                        <h6 class="mb-2 text-primary">Password</h6>
                                    </div>
                                    <div class="col-xl-12 col-lg-12 col-md-6 col-sm-6 col-12">
                                        <div class="form-group">
                                            <label>Current password</label>
                                            {{form.old_password}}
                                        </div>
                                    </div>
                                    <div class="col-xl-6 col-lg-6 col-md-6 col-sm-6 col-12">
                                        <div class="form-group">
                                            <label>New password</label>
                                            {{form.new_password1}}
                                        </div>
                                    </div>
                                    <div class="col-xl-6 col-lg-6 col-md-6 col-sm-6 col-12">
                                        <div class="form-group">
                                            <label>Repeat new password</label>
                                            {{form.new_password2}}
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
            <div class="text-right mt-3">
                <button type="submit" class="btn btn-primary" form="change-password">Save changes</button>
                <a type="button" href="{% url 'company:home' %}" class="btn btn-default">Back To Home</a>
            </div>
        </div>
    </div>
</div>
{% endblock %}

accounts/templates/accounts/delete-account.html
{% extends 'base.html' %}
{% load static %}
{%block content %}
<style>
	body {
    margin: 0;
    color: #2e323c;
    background: #f5f6fa;
    position: relative;
    height: 100%;
}

</style>
<div class="container" style="margin-top:70px;margin-bottom:70px">
    <div class="row gutters">
        <div class="col-lg-4 col-xl-4 col-md-12 col-sm-12 col-12">
            <div class="card-box text-center">
                <img src="{{ request.user.profile.image.url}}"
                     class="rounded-circle avatar-xl img-thumbnail" alt="profile-image">
                <h4 class="mb-0">{{request.user.full_name}}</h4>
                <p class="text-muted">{{request.user.email}}</p>
                <br>
                <label class="btn">
                    <i class="ti-upload"></i> Upload New photo
                    {{ form.image }}
                </label>
                <br>
                <br>
                <br>
                <div class="about">
                    <h5 class="mb-2 text-primary">About</h5>
                    <p>{{request.user.profile.bio}}</p>
                </div>
            </div>
            <hr class="border-light m-0">
            <div class="pt-0">
                <div class="list-group list-group-flush account-settings-links">
                    <a class="list-group-item list-group-item-action" href="{% url 'accounts:profile' request.user.id %}">General</a>
                    <a class="list-group-item list-group-item-action " href="{% url 'accounts:change-password' %}">Change password</a>
                    <a class="list-group-item list-group-item-action active" data-toggle="list" href="#account-Delete">Delete Account</a>
                </div>
            </div>
        </div>
        <div class="col-xl-8 col-lg-8 col-md-12 col-sm-12 col-12">
            <div class="tab-content">
                <div class="tab-pane fade active show text-center" id="account-Delete">
                    <h5 class="mb-2 text-primary" style="padding-top:120px">Are you sure you want to delete your account?</h5>
                    <br>
                    <button type="button" class="btn btn-primary"><a href="{% url 'accounts:delete-account-confirm' request.user.id %}">Delete My Account</a></button>
                </div>
            </div>
            <div class="text-center mt-3">
                <a type="button" href="{% url 'company:home' %}" class="btn btn-default">Back To Home</a>
            </div>
        </div>
    </div>
</div>
{% endblock %}

accounts/templates/accounts/login.html
{% extends 'base.html' %}
{% load static %}
{%block content %}

<!-- Breadcrumbs -->
<div class="breadcrumbs">
    <div class="container">
        <div class="row">
            <div class="col-12">
                <div class="bread-inner">
                    <ul class="bread-list">
                        <li><a href="#">Home<i class="ti-arrow-right"></i></a></li>
                        <li class="active"><a href="#">Login</a></li>
                    </ul>
                </div>
            </div>
        </div>
    </div>
</div>
<!-- End Breadcrumbs -->

<!-- Shop Login -->
<section class="shop login section">
    <div class="container">
        <div class="row">
            <div class="col-lg-6 offset-lg-3 col-12">
                <div class="login-form">
                    <h2>Login</h2>
                    <p>Please register in order to checkout more quickly</p>
                    <!-- Form -->
                    <form class="form" method="post" action="#">
                        {% csrf_token %}
                        <div class="row">
                            <div class="col-12">
                                <div class="form-group">
                                    <label>Your Email<span>*</span></label>
                                    {{form.email}}
                                </div>
                            </div>
                            <div class="col-12">
                                <div class="form-group">
                                    <label>Your Password<span>*</span></label>
                                    {{form.password}}
                                </div>
                            </div>
                            <div class="col-12">
                                <div class="form-group login-btn">
                                    <button class="btn" type="submit">Login</button>
                                    <a href="{% url 'accounts:register' %}" class="btn">Register</a>
                                </div>
                                <br>
                                <a href="#" class="lost-pass">Lost your password?</a>
                            </div>
                        </div>
                    </form>
                    <!--/ End Form -->
                </div>
            </div>
        </div>
    </div>
</section>
<!--/ End Login -->

{% endblock %}

accounts/templates/accounts/profile.html
{% extends 'base.html' %}
{% load static %}
{%block content %}
<style>
	body {
    margin: 0;
    color: #2e323c;
    background: #f5f6fa;
    position: relative;
    height: 100%;
}






</style>
<div class="container" style="margin-top:70px;margin-bottom:70px">
    <div class="row gutters">
        <div class="col-lg-4 col-xl-4 col-md-12 col-sm-12 col-12">
            <div class="card-box text-center">
                <img src="{{ request.user.profile.image.url}}"
                     class="rounded-circle avatar-xl img-thumbnail" alt="profile-image">
                <h4 class="mb-0">{{request.user.full_name}}</h4>
                <p class="text-muted">{{request.user.email}}</p>
                <br>
                <label class="btn">
                    <i class="ti-upload"></i> Upload New photo
                    {{ form.image }}
                </label>
                <br>
                <br>
                <br>
                <div class="about">
                    <h5 class="mb-2 text-primary">About</h5>
                    <p>{{request.user.profile.bio}}</p>
                </div>
            </div>
            <hr class="border-light m-0">
            <div class="pt-0">
                <div class="list-group list-group-flush account-settings-links">
                    <a class="list-group-item list-group-item-action active" data-toggle="list" href="#account-general">General</a>
                    <a class="list-group-item list-group-item-action"
                       href="{% url 'accounts:change-password' %}">Change password</a>
                    <a class="list-group-item list-group-item-action" href="{% url 'accounts:delete-account' %}">Delete Account</a>
                </div>
            </div>
        </div>
        <div class="col-xl-8 col-lg-8 col-md-12 col-sm-12 col-12">
            <div class="tab-content">
                <div class="tab-pane fade active show" id="account-general">
                    <div class="card h-100">
                        <div class="card-body">
                            <form method="post" id="profile-form" enctype="multipart/form-data">
                                {% csrf_token %}
                                <div class="row gutters">
                                    <div class="col-xl-12 col-lg-12 col-md-12 col-sm-12 col-12">
                                        <h6 class="mb-2 text-primary">Personal Details</h6>
                                    </div>
                                    <div class="col-xl-6 col-lg-6 col-md-6 col-sm-6 col-12">
                                        <div class="form-group">
                                            <label>Full Name</label>
                                            {{form.full_name}}
                                            <!--					<input type="text" class="form-control" id="fullName" placeholder="Enter full name">-->
                                        </div>
                                    </div>
                                    <div class="col-xl-6 col-lg-6 col-md-6 col-sm-6 col-12">
                                        <div class="form-group">
                                            <label>Email</label>
                                            {{form.email}}
                                        </div>
                                    </div>
                                    <div class="col-xl-6 col-lg-6 col-md-6 col-sm-6 col-12">
                                        <div class="form-group">
                                            <label>Phone</label>
                                            {{form.phone}}
                                        </div>
                                    </div>
                                    <div class="col-xl-6 col-lg-6 col-md-6 col-sm-6 col-12">
                                        <div class="form-group">
                                            <label>Age</label>
                                            {{form.age}}
                                        </div>
                                    </div>
                                    <div class="col-xl-6 col-lg-6 col-md-6 col-sm-6 col-12">
                                        <div class="form-group">
                                            <label>Bio</label>
                                            {{form.bio}}
                                        </div>
                                    </div>
                                    <div class="col-xl-6 col-lg-6 col-md-6 col-sm-6 col-12">
                                        <div class="form-group">
                                            <label>Country</label>
                                            {{form.country}}
                                        </div>
                                    </div>
                                </div>
                                <div class="row gutters">
                                    <div class="col-xl-12 col-lg-12 col-md-12 col-sm-12 col-12">
                                        <h6 class="mt-3 mb-2 text-primary">Address</h6>
                                    </div>
                                    <div class="col-xl-6 col-lg-6 col-md-6 col-sm-6 col-12">
                                        <div class="form-group">
                                            <label>Street</label>
                                            {{form.street}}
                                        </div>
                                    </div>
                                    <div class="col-xl-6 col-lg-6 col-md-6 col-sm-6 col-12">
                                        <div class="form-group">
                                            <label>City</label>
                                            {{form.city}}
                                        </div>
                                    </div>
                                    <div class="col-xl-6 col-lg-6 col-md-6 col-sm-6 col-12">
                                        <div class="form-group">
                                            <label>State</label>
                                            {{form.state}}
                                        </div>
                                    </div>
                                    <div class="col-xl-6 col-lg-6 col-md-6 col-sm-6 col-12">
                                        <div class="form-group">
                                            <label>Zip Code</label>
                                            {{form.zip_code}}
                                        </div>
                                    </div>
                                </div>
                            </form>
                        </div>

                    </div>
                </div>
            </div>
            <div class="text-right mt-3">
                <button type="submit" class="btn btn-primary" form="profile-form" >Save changes</button>
                <a type="button" href="{% url 'company:home' %}" class="btn btn-default">Back To Home</a>
            </div>
        </div>
    </div>
</div>
{% endblock %}